/* common definitions and data for dspscope modules */

#include <stdio.h>
#include <process.h>
#include <graph.h>

#ifndef FALSE
#define FALSE 0
#define TRUE  !FALSE
#endif

extern int *storage[8],k,count;
extern unsigned prt0,cntrlpt,prt1,prt2;

extern char version[];
extern struct  videoconfig config;
extern FILE *fp;	      /* current input file */
extern int xmin, ymin;	      /* Min x and y coord. */
extern int xmax, ymax;	      /* Max x and y coord  */
extern int lxmin, lymin;      /* Logical Min x and y coord. */
extern int lxmax, lymax;      /* Logical Max x and y coord  */
extern int xstep,ystep;       /* grid steps for x and y */
extern int maxxres,maxyres;   /* x and y resolution in pixels (nearest power of 2 ) */
extern unsigned int scale;    /* display vert scale value */
extern int tbase;	      /* display horz scale value */
extern int dstep;	      /* data step rate */
extern int ioff;	      /* current display offset in buffer */
extern int which;	      /* current display buffer */
extern int offset1;	      /* dc offset of channel 1 (input ) */
extern int offset2;	      /* dc offset of channel 2 (output) */
extern float srate;	      /* sample rate of data */
extern int lastbuf;	      /* number of last buffer in storage */
extern int dsply_chn;	      /* channel to display */

#define CONTROL 0x34
#define CONT2 0xb4
#define MAXBLK 4	  /* maximum number of blocks in file to process */
#define VOLTS  0.0024	  /* volts per count from A/D */
#define XGRIDS 10
#define YGRIDS 5
#define BOTH 2
#define CH1  0
#define CH2  1

void init_video(void);
void close_video(void);
void drawscrn(void);
FILE *getfile(void);
void edtbuf(void);
void newscreen(int ii, int which, int trace );
void drw_trc1(int ii, int which);
void drw_trc2(int ii, int which);
void showhelp(void);
void signon(void);
void data_input(void);
void data_io(int dir);
void load_320(void);
void run_debug( void );
void strtedit( void );
void run_mac320( void );
void proc_320(void);
void control_timer(long cnt, float osc, float *trate);
void fulbuf(int baseio, int which);
int ci(void);
void cflush(void);
void pktc(void);
