;
;	sintab	-	macro to generate twiddle factor lookup tables for
;			Decimation in Time FFT
;
;	cosine value in X memory
;	-sine value in Y memory
;
;	points	-	number of points (4 - 32768, power of 2)
;	twiddle	-	start of sine/cosine table
;

sintab	macro	points,twiddle

PI	equ	3.141592654
ENT	equ	points/2
FREQ	equ	PI/@cvf(ENT)

	org	x:twiddle
count	set	0
	dup	ENT
	dc	@cos(@cvf(count)*FREQ)
count	set	count+1
	endm

	org	y:twiddle
count	set	0
	dup	ENT
	dc	-@sin(@cvf(count)*FREQ)
count	set	count+1
	endm

	endm	;end of macro sintab
