        page 55,132
        title  tcla - click routine for tcl
        name tcla
;
;         tcla - click routine for tcl
;
;         for calling by msc programs (LARGE MODEL ONLY)
;
;         R. C. Allen   1987 August 11
;
;   *** asm functions MUST preserve SI, DI, ES, BP, DS, SS
;
;       int returns in AX
;      long returns in DX:AX
;

PORT    equ     61h             ; the control port on pc


_text   segment byte public 'CODE'
_text   ends
_data   segment word public 'DATA'
_data   ends
const   segment word public 'CONST'
const   ends
_bss    segment word public 'BSS'
_bss    ends

dgroup  group const, _bss, _data
        assume cs: _text, ds: dgroup, ss: dgroup, es:dgroup

        ; define argument stack offsets

@ab     equ     6               ; large model offset
arga	equ	@ab             ; arg a
argb    equ     @ab+2           ; arg b
argc    equ     @ab+4           ; arg c
argd    equ     @ab+6           ; arg d
arge    equ     @ab+8           ; arg e


_text   segment         ; code in this segment

;
;       void click(tconst);     /* wwv style click to speaker */
;       int tconst;             /* timing constant for cpu */
;
;  NOTE: This routine operates with interrupts disabled so
;        keep 'tconst' low ...
;
        public _click

_click  proc    far

	push bp                         ; save bp
	mov bp,sp                       ; -> arguments

        cli                             ; ***** no interrupts *****

        in al,PORT                      ; fetch port value
        push ax                         ; save for later
        and al,11111110b                ; set direct mode
        out PORT,al                     ; on parallel port
        mov cx,6                        ; iteration count
deloop:
        in al,PORT                      ; current port state
        xor al,00000010b                ; invert cone state
        out PORT,al                     ; new state
        push cx                         ; save outer loop count
        mov cx,arga[bp]                 ; cpu time constant
q:      loop q                          ; inter cycle delay
        pop cx                          ; restore outer loop count
        loop deloop                     ; continue

        pop ax                          ; original control port
        out PORT,al                     ;  is restored
        sti                             ; interrupts back on
        pop bp                          ;   restore bp
        ret                             ;    and leave ...

_click  endp

_text   ends

_data   segment                 ; data here
_data   ends

	end
